const API = require('./api')
const config = require('./config')

const cookies = [
  // {
  //     "domain": ".pchome.com.tw",
  //     "expirationDate": 3737573385.73491,
  //     "hostOnly": false,
  //     "httpOnly": false,
  //     "name": "ECC",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "9498e803debc39fefc74dc9d7b0d9252dc3bd7bb.1590089738",
  //     "id": 1
  // },
  {
    'domain': '.pchome.com.tw',
    'expirationDate': 1653162484.938356,
    'hostOnly': false,
    'httpOnly': true,
    'name': 'ECWEBSESS',
    'path': '/',
    'sameSite': 'unspecified',
    'secure': false,
    'session': false,
    'storeId': '0',
    'value': 'aabd678928.4176593c8ff65ccc922b92e1551cc27dad0f3210.1590089565',
    'id': 2
  }
  // {
  //     "domain": ".pchome.com.tw",
  //     "expirationDate": 1591299999,
  //     "hostOnly": false,
  //     "httpOnly": false,
  //     "name": "HistoryEC",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "%7B%22P%22%3A%5B%7B%22Id%22%3A%22DAACC6-1900AKQLB%22%2C%20%22M%22%3A1590090399%7D%5D%2C%20%22T%22%3A1%7D",
  //     "id": 3
  // },
  // {
  //     "domain": ".pchome.com.tw",
  //     "expirationDate": 1590091675.146704,
  //     "hostOnly": false,
  //     "httpOnly": false,
  //     "name": "MBR",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "david27072183%40yahoo.com.tw",
  //     "id": 4
  // },
  // {
  //     "domain": ".pchome.com.tw",
  //     "expirationDate": 1590176275.222151,
  //     "hostOnly": false,
  //     "httpOnly": false,
  //     "name": "PRI_david27072183%40yahoo.com.tw",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "0",
  //     "id": 5
  // },
  // {
  //     "domain": ".pchome.com.tw",
  //     "hostOnly": false,
  //     "httpOnly": false,
  //     "name": "recomdId",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": true,
  //     "storeId": "0",
  //     "value": "rg1-hh06_normal_1590119281_128825822",
  //     "id": 6
  // },
  // {
  //     "domain": ".pchome.com.tw",
  //     "expirationDate": 1621625874.971384,
  //     "hostOnly": false,
  //     "httpOnly": false,
  //     "name": "U",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "fed1a01c3ed864bd2245e3abf3dfb38f05a9fede",
  //     "id": 7
  // },
  // {
  //     "domain": ".pchome.com.tw",
  //     "expirationDate": 1905449875,
  //     "hostOnly": false,
  //     "httpOnly": false,
  //     "name": "venguid",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "ae2f5891-c480-490a-ad3f-fa7f0d536176.wg1-xvxf20200522",
  //     "id": 8
  // },
  // {
  //     "domain": ".pchome.com.tw",
  //     "expirationDate": 1590092285,
  //     "hostOnly": false,
  //     "httpOnly": false,
  //     "name": "vensession",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "260614a8-cc57-461d-88e8-5a4c3fb3de46.wg1-xvxf20200522.se",
  //     "id": 9
  // },
  // {
  //     "domain": ".pchome.com.tw",
  //     "expirationDate": 1747769789.334073,
  //     "hostOnly": false,
  //     "httpOnly": true,
  //     "name": "X",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "7763211",
  //     "id": 10
  // },
  // {
  //     "domain": "24h.pchome.com.tw",
  //     "expirationDate": 1621626399.840632,
  //     "hostOnly": true,
  //     "httpOnly": false,
  //     "name": "PCHOMEUNIQID",
  //     "path": "/",
  //     "sameSite": "unspecified",
  //     "secure": false,
  //     "session": false,
  //     "storeId": "0",
  //     "value": "403518f48950a15b5841f2fa94b50fb1",
  //     "id": 11
  // }
]

Object.assign(process.env, config)

const productionId = process.env.PROD_ID || 'DGBJHC-1900AO2VR-000'

async function main () {
  let success = false
  while (!success) {
    try {
      const api = new API(cookies)
      const snapupResult = await api.snapup(productionId)
      const addCartResult = await api.add2Cart(productionId, snapupResult, 1)
      console.log(addCartResult)
      const res = await api.getCartInfo()
      // console.dir(res)
      // console.dir(res.itemlist.houses, {depth: 8})
      // console.dir(res.payment, {depth: 8})
      console.log((res.shoppingFee) ? '要運費' : '免運費')
      console.log((res.payment.COD.status === 'Y') ? '可貨到付款' : '不可貨到付款')
      if (res.shoppingFee || res.payment.COD.status === 'N') {
        return console.log('取消流程')
      }

      // const result = await api.order({
      //   // test: true,
      //   cusName: '劉威良',
      //   cusMobile: '0908787870',
      //   cusZip: '30010',
      //   cusAddress: '新竹市東區大學路1001號研一舍202室',
      //   recName: '劉威良',
      //   recMobile: '0908787870',
      //   recZip: '30010',
      //   recAddress: '新竹市東區大學路1001號研一舍202室'
      // })

      // if (result.status === 'ERR') {
      //   throw new Error(result.msg)
      // }
      // console.log(res)
      success = true
    } catch (err) {
      console.error(err)
    }
  }
}

main()
